* ReverseSEigen.F
* recover the original matrix A from the (complex) eigenvalues
* and the transformation matrix U by forming A = U^T diag(d) U.
* this file is part of the Diag library
* last modified 21 Aug 15 th

#include "diag-f.h"


	subroutine ReverseSEigen(n, A,ldA, d, U,ldU)
	implicit none
	integer n, ldA, ldU
	ComplexType A(ldA,*), U(ldU,*), d(*)

	integer i, j, k
	ComplexType s

	do j = 1, n
	  do i = 1, n
	    s = 0
	    do k = 1, n
	      s = s + d(k)*UL(k,i)*UL(k,j)
	    enddo
	    A(i,j) = s
	  enddo
	enddo
	end

